/*------------------------------------------------------------------------
    File        : BaseMethodTester
    Purpose     : 
  ----------------------------------------------------------------------*/

USING Progress.Lang.*.
USING OEUnit.Assertion.*.
USING OEMock.Reflection.*.

ROUTINE-LEVEL ON ERROR UNDO, THROW.

CLASS OEMock.Tests.Reflection.BaseMethodTester:
    
    @Test.
    METHOD PUBLIC VOID ConstructorSetsName():
        DEFINE VARIABLE meth AS BaseMethod NO-UNDO.
        
        meth = NEW BaseMethod('Method Name').
        
        Assert:AreEqual(meth:Name,'Method Name').
        
        IF VALID-OBJECT(meth) THEN DELETE OBJECT meth.
    END METHOD.
    
    @Test.
    METHOD PUBLIC VOID ConstructorCreatesGeneratorList():
        DEFINE VARIABLE meth AS BaseMethod NO-UNDO.
        
        meth = NEW BaseMethod('Method Name').
        
        Assert:IsTrue(VALID-OBJECT(meth:Generators)).
        
        IF VALID-OBJECT(meth) THEN DELETE OBJECT meth.
    END METHOD.
    
    @Test.
    METHOD PUBLIC VOID ConstructorCreatesParameterList():
        DEFINE VARIABLE meth AS BaseMethod NO-UNDO.
        
        meth = NEW BaseMethod('Method Name').
        
        Assert:IsTrue(VALID-OBJECT(meth:Parameters)).
        
        IF VALID-OBJECT(meth) THEN DELETE OBJECT meth.
    END METHOD.
    
    @Test.
    METHOD PUBLIC VOID DoesNotRequireForwardDeclaration():
        DEFINE VARIABLE meth AS BaseMethod NO-UNDO.
        
        meth = NEW BaseMethod('Method Name').
        
        Assert:AreEqual(meth:RequireForward,FALSE).
        
        IF VALID-OBJECT(meth) THEN DELETE OBJECT meth.
    END METHOD.
    
    @Test.
    METHOD PUBLIC VOID GenerateReturnsBlank():
        DEFINE VARIABLE meth AS BaseMethod NO-UNDO.
        
        meth = NEW BaseMethod('Method Name').
        
        Assert:AreEqual(meth:Generate(), '').
        
        IF VALID-OBJECT(meth) THEN DELETE OBJECT meth.
    END METHOD.
    
    @Test.
    METHOD PUBLIC VOID GenerateForwardReturnsBlank():
        DEFINE VARIABLE meth AS BaseMethod NO-UNDO.
        
        meth = NEW BaseMethod('Method Name').
        
        Assert:AreEqual(meth:GenerateForward(), '').
        
        IF VALID-OBJECT(meth) THEN DELETE OBJECT meth.
    END METHOD.

END CLASS.